//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
// ENBSeries effect file                                            //
// visit http://enbdev.com for updates                              //
// Copyright (c) 2007-2013 Boris Vorontsov                          //
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//                                                                  //
//  Weather TODIE enbeffect.fx by kingeric1992                      //
//                                                                  //
//  Featuring:                                                      //
//     Weather dependent                                            //
//        Dawn, Sunrise, Day, Sunset, Dusk, Night setup             //
//          on Exterior/Interior seperation.                        //
//                                                                  //
//     Along with custom SplitTone, LutAtlas, Dithering             //
//                                                                  //
//  Visit                                                           //
//    http://enbseries.enbdev.com/forum/viewtopic.php?f=7&t=5310    //
//                                           for more info          //
//  update: Nov.23.2016                                             //
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//


string Title0 = "\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4\xA4";
float  Dither_Amplitude  < string UIName="Dither Amplitude";     > = {0.5};
float  Noise_Frequency   < string UIName="Dither Frequency";     > = {1.0};
float  ST_LowRange       < string UIName="SplitTone LowRange";   > = {0.3333};
float  ST_HighRange      < string UIName="SplitTone HighRange";  > = {0.6666};
string ME =" _(:3 \xB8/)_";

//fill in the input arrays and WeatherIndex() in TODIE section accordingly
#define WEATHERCOUNT 2 

//set these to match to enbseries.ini [TIME OF DAY]
#define TOD_DAWN_DURATION   2
#define TOD_DUSK_DURATION   2
#define TOD_SUNRISE_TIME    6   
#define TOD_DAY_TIME        12
#define TOD_SUNSET_TIME     18
#define TOD_NIGHT_TIME      0


#define LUM_COEFF  float3(0.2125, 0.7154, 0.0721)   //709
#define DELTA      0.0000001

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//external parameters, do not modify
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//keyboard controlled temporary variables (in some versions exists in the config file).
float4 tempF1, tempF2, tempF3; // 1,2,3,4,5,6,7,8,9,0, Press and hold key 1,2,3...8 together with PageUp or PageDown to modify. By default all set to 1.0
float4 ScreenSize;             // x=Width, y=1/Width, z = Width/Height, w = Height/Width
float4 Timer;                  // x=generic timer in range 0..1, period of 16777216 ms (4.6 hours), w=frame time elapsed (in seconds)
float  ENightDayFactor = 0.0;  // Changes in range 0..1, 0 means that night time, 1 - day time
float  EInteriorFactor = 0.0;  // Changes 0 or 1. 0 means that exterior, 1 - interior
float  EAdaptiveQualityFactor; // Changes in range 0..1, 0 means full quality, 1 lowest dynamic quality (0.33, 0.66 are limits for quality levels)
float4 WeatherAndTime = float4(0.0, 0.0, 0.0, 0.0);         // x=current weather index, y=outgoing weather index, z=weather transition, w=time of the day in 24 standard hours.
float  FieldOfView;            // FoV in degrees
float  EBloomAmount;           // enb version of bloom applied, ignored if original post processing used.

//skyrim shader specific externals, do not modify
float4  _c1 : register(c1);
float4  _c2 : register(c2);
float4  _c3 : register(c3);
float4  _c4 : register(c4);
float4  _c5 : register(c5);

texture2D texs0;    //color
texture2D texs1;    //bloom skyrim
texture2D texs2;    //adaptation skyrim
texture2D texs3;    //bloom enb
texture2D texs4;    //adaptation enb
texture2D texs7;    //palette enb

//samplerColor
sampler2D _s0 = sampler_state
{
    Texture = <texs0>;
    SRGBTexture =FALSE;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = Clamp; AddressV  = Clamp;
    MaxMipLevel=0; MipMapLodBias=0;
};

//samplerSkrimBloom
sampler2D _s1 = sampler_state
{
    Texture   = <texs1>;
    SRGBTexture =FALSE;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = Clamp; AddressV  = Clamp;
    MaxMipLevel=0; MipMapLodBias=0;
};

//samplerSkyrimGray
sampler2D _s2 = sampler_state
{
    Texture   = <texs2>;
    SRGBTexture =FALSE;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = Clamp; AddressV  = Clamp;
    MaxMipLevel=0; MipMapLodBias=0;
};

//samplerBloom
sampler2D _s3 = sampler_state
{
    Texture   = <texs3>;
    SRGBTexture =FALSE;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = Clamp; AddressV  = Clamp;
    MaxMipLevel=0; MipMapLodBias=0;
};

//samplerAdaptation
sampler2D _s4 = sampler_state
{
    Texture   = <texs4>;
    SRGBTexture =FALSE;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = Clamp; AddressV  = Clamp;
    MaxMipLevel=0; MipMapLodBias=0;
};

//samplerPalette
sampler2D _s7 = sampler_state
{
    Texture   = <texs7>;
    SRGBTexture =FALSE;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = Clamp; AddressV  = Clamp;
    MaxMipLevel=0; MipMapLodBias=0;
};

#include "enbeffect_colorcorrection.fxh"

struct InputStruct
{
    float               PassWeight;
    float               Exposure, Lwhite, Curve;
    GameCCStruct        GameCCData; 
    ChannelMixerStruct  ChannelMixerData;
    LutAtlasStruct      LutAtlasData;
    ColorWheelStruct    ColorWheelData;     
    SplitToneStruct     SplitToneData;
};

// ALU noise in Next-gen post processing in COD:AW 
float InterleavedGradientNoise( float2 uv )
{
    float3 magic = { 0.06711056, 0.00583715, 52.9829189 };
    return frac( magic.z * frac(dot(uv, magic.xy)));
}

//energy-preserved dithering [Lottes16]
float3 Dither( float3 color, float amp, float2 uv)
{
    float noise = lerp(-0.5, 0.5, InterleavedGradientNoise( uv * Noise_Frequency)) * amp;
    color  = pow(saturate(color), 1.0/2.2);
    color += noise * min(color + 0.5 * pow(1.0/255.0, 2.2), 0.75 * (pow(256.0/255.0, 2.2) - 1.0));
    return pow(saturate(color), 2.2);
}

float3 Reinhard( float3 color, float Lwhite, float Curve) 
{
    return color / (max(color.r, max(color.g, color.b)) + Curve) * (1 + Curve / Lwhite);
}

void VS_Quad( inout float4 pos : POSITION, inout float2 txcoord0 : TEXCOORD0) 
{   pos.w = 1.0; }

float4 PS_Draw(float2 txcoord0 : TEXCOORD0, float2 vpos : VPOS, uniform InputStruct IN, uniform sampler2D LutS) : COLOR
{
    float4 res   = tex2D(_s0, txcoord0);
    float4 bloom = tex2D(_s3, txcoord0);
    float3 color = (res.rgb + bloom.rgb * max( EBloomAmount - res.rgb, 0.0)) * IN.Exposure;
    color = Reinhard(color, IN.Lwhite, IN.Curve); 
    color = lerp(color, LutAtlas(     saturate(color), IN.LutAtlasData, LutS), IN.LutAtlasData.Weight     * IN.LutAtlasData.State     ); 
    color = lerp(color, ColorWheel(   saturate(color), IN.ColorWheelData),     IN.ColorWheelData.Weight   * IN.ColorWheelData.State   );  
    color = lerp(color, GameCC(       saturate(color), IN.GameCCData),         IN.GameCCData.Weight       * IN.GameCCData.State       ); //double check this
    color = lerp(color, ChannelMixer( saturate(color), IN.ChannelMixerData),   IN.ChannelMixerData.Weight * IN.ChannelMixerData.State ); //double check this
    color = lerp(color, SplitTone(    saturate(color), IN.SplitToneData),      IN.SplitToneData.Weight    * IN.SplitToneData.State    );

    return float4(saturate(Dither(color, Dither_Amplitude, vpos)), IN.PassWeight);
}
   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//  TODIE
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


//WeatherIndex.x = curr weather
//WeatherIndex.y = prev weather
//add condition here to convert ENB WeatherAndTime index to TODIE index
float2 WeatherIndex() { return clamp(round(WeatherAndTime.xy), 0.0, WEATHERCOUNT - 1.0 ); };

static float WeatherWeight( float I) { return (WeatherIndex().x == WeatherIndex().y)? 0.5: ((I == WeatherIndex().x)? WeatherAndTime.z : 1.0 - WeatherAndTime.z); };

#define TOD_DAWN_TIME       (TOD_SUNRISE_TIME - 0.5 * TOD_DAWN_DURATION)
#define TOD_DUSK_TIME       (TOD_SUNSET_TIME  + 0.5 * TOD_DUSK_DURATION)

struct TODstruct { float dawn, sunrise, day, sunset, dusk, night; };

TODstruct TOD()
{
    TODstruct o;
    
    float2 quad = { step(WeatherAndTime.w, TOD_DAY_TIME), step(TOD_DAWN_TIME, WeatherAndTime.w) * step(WeatherAndTime.w, TOD_DUSK_TIME)};
    float  tmp  = quad.x > 0.5 ? TOD_SUNRISE_TIME: TOD_SUNSET_TIME;
    
    o.dawn    = max(1.0 - abs((WeatherAndTime.w - TOD_DAWN_TIME)/(0.5 * TOD_DAWN_DURATION)),0.0);
    o.day     = pow(saturate((tmp - WeatherAndTime.w)/(tmp - TOD_DAY_TIME)), 0.6);
    o.dusk    = max(1.0 - abs((WeatherAndTime.w - TOD_DUSK_TIME)/(0.5 * TOD_DUSK_DURATION)),0.0);
    o.sunrise = max(quad.x * quad.y - (o.day + o.dawn), 0.0);
    o.sunset  = max((1.0 - quad.x) * quad.y - (o.day + o.dusk), 0.0);
    o.night   = max((1.0 - quad.y) - (o.dusk + o.dawn), 0.0);
    
    return o;
}

static float TODINDEX = float(
    step(TOD_SUNRISE_TIME, WeatherAndTime.w) +
    step(TOD_DAY_TIME,     WeatherAndTime.w) +
    step(TOD_SUNSET_TIME,  WeatherAndTime.w) +
    step(TOD_DUSK_TIME,    WeatherAndTime.w) +
    step(WeatherAndTime.w, TOD_DAWN_TIME) * 5.0 );

static float3 Adapt = tex2D(_s4, 0.5).rgb;

#define TOSTRING(a) #a

#define suffix Dawn
string  s0_Dawn  ="____________________";
string  s1_Dawn  ="<<<<<  Dawn  >>>>>";
string  s2_Dawn  ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define PASSWEIGHT float(WeatherWeight(0) * TOD().dawn)
#include "enbeffect_UI.fxh"

#define suffix Sunrise
string  s0_Sunrise  ="____________________";
string  s1_Sunrise ="<<<<< Sunrise >>>>>";
string  s2_Sunrise  ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define PASSWEIGHT float(WeatherWeight(0) * TOD().sunrise)
#include "enbeffect_UI.fxh"

#define suffix Day
string  s0_Day  ="____________________";
string  s1_Day ="<<<<<   Day   >>>>>";
string  s2_Day  ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define PASSWEIGHT float(WeatherWeight(0) * TOD().day)
#include "enbeffect_UI.fxh"

#define suffix Sunset
string  s0_Sunset  ="____________________";
string  s1_Sunset ="<<<<< Sunset >>>>>";
string  s2_Sunset  ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define PASSWEIGHT float(WeatherWeight(0) * TOD().sunset)
#include "enbeffect_UI.fxh"

#define suffix Dusk
string  s0_Dusk  ="____________________";
string  s1_Dusk ="<<<<<  Dusk  >>>>>";
string  s2_Dusk  ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define PASSWEIGHT float(WeatherWeight(0) * TOD().dusk)
#include "enbeffect_UI.fxh"

#define suffix Night
string  s0_Night  ="____________________";
string  s1_Night ="<<<<<  Night  >>>>>";
string  s2_Night  ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define PASSWEIGHT float(WeatherWeight(0) * TOD().night)
#include "enbeffect_UI.fxh"

//Load static preset assets 
//#include "enbeffect_preset.fxh" 

//example of a preset
static InputStruct EmptyW1 = {
    WeatherWeight(1) * 0.25, _c1.y,  1.0, 1.0,
    {   true,   1.0, float4(_c3.x, tex2D(_s2, 0.5).x * _c1.y, _c3.zw), _c4, _c5 },
    {   false,  1.0, { float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)} },
    {   false,  1.0, float2(12.0, WEATHERCOUNT), float2((TODINDEX + 1) % 6 + 6.0 * EInteriorFactor, 1.0) },
    {   false,  1.0, float3(0.0, 0.0, 0.0) },
    {   false,  1.0, ST_LowRange, ST_HighRange, 0.005,
        float3(0.0, 0.0, 0.0), float3(0.0, 0.0, 0.0), float3(0.0, 0.0, 0.0),
        float3(0.0, 0.0, 0.0), float3(0.0, 0.0, 0.0), float3(0.0, 0.0, 0.0)}
};

texture2D LUTtex <string ResourceName="TODIE_LUT.bmp"; >; 

sampler2D samplerLUT = sampler_state { 
    Texture = < LUTtex >; 
    SRGBTexture =FALSE; 
    MinFilter = LINEAR ; MagFilter = LINEAR ; MipFilter = NONE; 
    AddressU  = Clamp ; AddressV  = Clamp ; 
    MaxMipLevel=0; MipMapLodBias=0;
};

struct TODIEstruct { InputStruct dawn, sunrise, day, sunset, dusk, night; };

static TODIEstruct TODIE_W0[2] =
{
    {UI_Dawn, UI_Sunrise, UI_Day, UI_Sunset, UI_Dusk, UI_Night}, //Exterior
    {UI_Dawn, UI_Sunrise, UI_Day, UI_Sunset, UI_Dusk, UI_Night}  //Interior
};

static TODIEstruct TODIE_W1[2] =
{
    {EmptyW1, EmptyW1, EmptyW1, EmptyW1, EmptyW1, EmptyW1}, // Exterior
    {EmptyW1, EmptyW1, EmptyW1, EmptyW1, EmptyW1, EmptyW1}  // Interior
};

PixelShader PS_TODIE[6 * WEATHERCOUNT] = 
{
    compile ps_3_0 PS_Draw(TODIE_W0[EInteriorFactor].dawn,    samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W0[EInteriorFactor].sunrise, samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W0[EInteriorFactor].day,     samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W0[EInteriorFactor].sunset,  samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W0[EInteriorFactor].dusk,    samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W0[EInteriorFactor].night,   samplerLUT),
    
    compile ps_3_0 PS_Draw(TODIE_W1[EInteriorFactor].dawn,    samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W1[EInteriorFactor].sunrise, samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W1[EInteriorFactor].day,     samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W1[EInteriorFactor].sunset,  samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W1[EInteriorFactor].dusk,    samplerLUT),
    compile ps_3_0 PS_Draw(TODIE_W1[EInteriorFactor].night,   samplerLUT)
};

//blending == p0*a0 + p1*a1 + p2*a2 + p3*a3;
technique Shader_D6EC7DD1 <string UIName="TODIE";>
{
    pass p0 {  
        VertexShader = compile vs_3_0 VS_Quad(); 
        PixelShader  = PS_TODIE[clamp(TODINDEX + 6 * WeatherIndex().x, 0.0, 6 * WEATHERCOUNT - 1)];
        ColorWriteEnable=ALPHA|RED|GREEN|BLUE; 
        ZEnable=FALSE;  
        ZWriteEnable=FALSE; 
        CullMode=NONE;  
        AlphaTestEnable=FALSE;  
        AlphaBlendEnable=TRUE;
        SrcBlend=SRCALPHA;
        DestBlend=Zero;
        SRGBWRITEENABLE=FALSE;  
    }
    pass p1 {  
        VertexShader = compile vs_3_0 VS_Quad(); 
        PixelShader  = PS_TODIE[clamp((TODINDEX + 1) % 6 + 6 * WeatherIndex().x, 0.0, 6 * WEATHERCOUNT - 1)];
        ColorWriteEnable=ALPHA|RED|GREEN|BLUE; 
        ZEnable=FALSE;  
        ZWriteEnable=FALSE; 
        CullMode=NONE;  
        AlphaTestEnable=FALSE;  
        AlphaBlendEnable=TRUE;
        SrcBlend=SRCALPHA;
        DestBlend=ONE;
        SRGBWRITEENABLE=FALSE;  
    } 
    pass p2 {  
        VertexShader = compile vs_3_0 VS_Quad(); 
        PixelShader  = PS_TODIE[clamp(TODINDEX + 6 * WeatherIndex().y, 0.0, 6 * WEATHERCOUNT - 1)];
        ColorWriteEnable=ALPHA|RED|GREEN|BLUE; 
        ZEnable=FALSE;  
        ZWriteEnable=FALSE; 
        CullMode=NONE;  
        AlphaTestEnable=FALSE;  
        AlphaBlendEnable=TRUE;
        SrcBlend=SRCALPHA;
        DestBlend=ONE;
        SRGBWRITEENABLE=FALSE;  
    }
    pass p3 {  
        VertexShader = compile vs_3_0 VS_Quad(); 
        PixelShader  = PS_TODIE[clamp((TODINDEX + 1) % 6 + 6 * WeatherIndex().y, 0.0, 6 * WEATHERCOUNT - 1)];
        ColorWriteEnable=ALPHA|RED|GREEN|BLUE; 
        ZEnable=FALSE;  
        ZWriteEnable=FALSE; 
        CullMode=NONE;  
        AlphaTestEnable=FALSE;  
        AlphaBlendEnable=TRUE;
        SrcBlend=SRCALPHA;
        DestBlend=ONE;
        SRGBWRITEENABLE=FALSE;  
    }
}
    
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//  Preset Helper
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#define suffix Helper
string  s0_Helper ="_______________________";
string  s1_Helper ="<<<< Preset Helper >>>>";
string  s2_Helper ="\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF\xAF";
#define LUTINDEX_XY float2(0.0, 0.0)
#define LUTSTACK_XY float2(1.0, 1.0)
#include "enbeffect_UI.fxh"

texture2D BaseLUTtex <string ResourceName="BaseLUT.bmp"; >; 

sampler2D samplerBaseLUT = sampler_state { 
    Texture = < BaseLUTtex >; 
    SRGBTexture =FALSE; 
    MinFilter = LINEAR ; MagFilter = LINEAR ; MipFilter = NONE; 
    AddressU  = Clamp ; AddressV  = Clamp ; 
    MaxMipLevel=0; MipMapLodBias=0;
};

technique TODIE_Helper <string UIName="TODIE Helper";>
{
    pass p0 {  
        VertexShader = compile vs_3_0 VS_Quad(); 
        PixelShader  = compile ps_3_0 PS_Draw(UI_Helper, samplerBaseLUT);
        ColorWriteEnable=ALPHA|RED|GREEN|BLUE; 
        ZEnable=FALSE;  
        ZWriteEnable=FALSE; 
        CullMode=NONE;  
        AlphaTestEnable=FALSE;  
        AlphaBlendEnable=FALSE;
        SRGBWRITEENABLE=FALSE;  
    }
}

//original shader of post processing
technique Shader_ORIGINALPOSTPROCESS <string UIName="Vanilla";>
{
    pass p0
    {
        VertexShader  = compile vs_3_0 VS_Quad();
        PixelShader=
    asm
    {
// Parameters:
//   sampler2D Avg;
//   sampler2D Blend;
//   float4 Cinematic;
//   float4 ColorRange;
//   float4 Fade;
//   sampler2D Image;
//   float4 Param;
//   float4 Tint;
// Registers:
//   Name         Reg   Size
//   ------------ ----- ----
//   ColorRange   c1       1
//   Param        c2       1
//   Cinematic    c3       1
//   Tint         c4       1
//   Fade         c5       1
//   Image        s0       1
//   Blend        s1       1
//   Avg          s2       1
//s0 bloom result
//s1 color
//s2 is average color

    ps_3_0
    def c6, 0, 0, 0, 0
    //was c0 originally
    def c7, 0.212500006, 0.715399981, 0.0720999986, 1
    dcl_texcoord v0.xy
    dcl_2d s0
    dcl_2d s1
    dcl_2d s2
    rcp r0.x, c2.y
    texld r1, v0, s2
    mul r0.yz, r1.xxyw, c1.y
    rcp r0.w, r0.y
    mul r0.z, r0.w, r0.z
    texld r1, v0, s1
    mul r1.rgb, r1, c1.y
    dp3 r0.w, c7, r1
    mul r1.w, r0.w, r0.z
    mad r0.z, r0.z, r0.w, c7.w
    rcp r0.z, r0.z
    mad r0.x, r1.w, r0.x, c7.w
    mul r0.x, r0.x, r1.w
    mul r0.x, r0.z, r0.x
    cmp r0.x, -r0.w, c6.x, r0.x
    rcp r0.z, r0.w
    mul r0.z, r0.z, r0.x
    add_sat r0.x, -r0.x, c2.x
    texld r2, v0, s0
    mul r2.rgb, r2, c1.y
    mul r2.rgb, r0.x, r2
    mad r1.rgb, r1, r0.z, r2
    dp3 r0.x, r1, c7
    mov r1.w, c7.w
    lrp r2, c3.x, r1, r0.x
    mad r1, r0.x, c4, -r2
    mad r1, c4.w, r1, r2
    mad r1, c3.w, r1, -r0.y
    mad r0, c3.z, r1, r0.y
    add r1, -r0, c5
    mad oC0, c5.w, r1, r0
    };
        ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
        ZEnable=FALSE;
        ZWriteEnable=FALSE;
        CullMode=NONE;
        AlphaTestEnable=FALSE;
        AlphaBlendEnable=FALSE;
        SRGBWRITEENABLE=FALSE;
    }
}